#include "sys.h"
#include "delay.h"  
#include "usart.h"  
#include "led.h"

#include "usmart.h"
#include "rtc.h"

#include "GUI.h"
#include "Lcd_Driver.h"

//RTCʵʱʱ ʵ -⺯汾
//STM32F4ģ-⺯汾
//Ա̣http://mcudev.taobao.com	

	u8 tbuf[40];
	u8 t=0;
	
int main(void)
{ 

	RTC_TimeTypeDef RTC_TimeStruct;
	RTC_DateTypeDef RTC_DateStruct;


	NVIC_PriorityGroupConfig(NVIC_PriorityGroup_2);//ϵͳжȼ2
	delay_init(168);      //ʼʱ
	uart_init(115200);		//ʼڲΪ115200
	
	usmart_dev.init(84); 	//ʼUSMART	
	LED_Init();					  //ʼLED
	
 	Lcd_Init();	 //1.44Һ--ʼ
	Lcd_Clear(GRAY0);//
	Gui_DrawFont_GBK16(0,16,RED,GRAY0,"    STM32 RTC ");
  Gui_DrawFont_GBK16(0,32,BLUE,GRAY0,"  Ƕʽ   ");	 
	Gui_DrawFont_GBK16(0,48,BLUE,GRAY0,"mcudev.taobao.com "); 
	
	
	My_RTC_Init();		 		//ʼRTC
 
	RTC_Set_WakeUp(RTC_WakeUpClock_CK_SPRE_16bits,0);		//WAKE UPж,1жһ
	
	
  	while(1) 
	{		
		t++;
		if((t%10)==0)	//ÿ100msһʾ
		{
;
			RTC_GetTime(RTC_Format_BIN,&RTC_TimeStruct);
			
			sprintf((char*)tbuf,"Time:%02d:%02d:%02d",RTC_TimeStruct.RTC_Hours,RTC_TimeStruct.RTC_Minutes,RTC_TimeStruct.RTC_Seconds); 
				
			Gui_DrawFont_GBK16(0,64,RED,GRAY0,tbuf);
			
			RTC_GetDate(RTC_Format_BIN, &RTC_DateStruct);
			
			sprintf((char*)tbuf,"Date:20%02d-%02d-%02d",RTC_DateStruct.RTC_Year,RTC_DateStruct.RTC_Month,RTC_DateStruct.RTC_Date); 
			
			Gui_DrawFont_GBK16(0,80,RED,GRAY0,tbuf);	
			
			sprintf((char*)tbuf,"Week:%d",RTC_DateStruct.RTC_WeekDay); 
			
			Gui_DrawFont_GBK16(0,96,RED,GRAY0,tbuf);
		} 
		if((t%20)==0)LED2=!LED2;	//ÿ200ms,תһLED2 
		delay_ms(10);
	}	
}
