#include "sys.h"
#include "delay.h"  
#include "usart.h"  
#include "led.h"
#include "key.h"

#include "timer.h" 
#include "math.h" 
#include "arm_math.h"  

#include "GUI.h"
#include "Lcd_Driver.h"
 
//DSP BasicMathʵ -⺯汾
//STM32F4ģ-⺯汾
//Ա̣http://mcudev.taobao.com


#define	DELTA	0.000001f		//ֵ
 
//sin cos
//angle:ʼǶ
//times:
//mode:0,ʹDSP;1,ʹDSP
//ֵ0,ɹ;0XFF,
u8 sin_cos_test(float angle,u32 times,u8 mode)
{
	float sinx,cosx;
	float result;
	u32 i=0;
	if(mode==0)
	{
		for(i=0;i<times;i++)
		{
			cosx=cosf(angle);			//ʹDSPŻsincos
			sinx=sinf(angle);
			result=sinx*sinx+cosx*cosx; //Ӧõ1  
			result=fabsf(result-1.0f);	//Ա1Ĳֵ
			if(result>DELTA)return 0XFF;//жʧ 
			angle+=0.001f;				//Ƕ
		}
	}else
	{
		for(i=0;i<times;i++)
		{
			cosx=arm_cos_f32(angle);	//ʹDSPŻsincos
			sinx=arm_sin_f32(angle);
			result=sinx*sinx+cosx*cosx; //Ӧõ1  
			result=fabsf(result-1.0f);	//Ա1Ĳֵ
			if(result>DELTA)return 0XFF;//жʧ 
			angle+=0.001f;				//Ƕ
		}
	}
	return 0;//
} 
u8 timeout;//ʱ


int main(void)
{ 
	float time; 
	u8 buf[50];
	u8 res;

	NVIC_PriorityGroupConfig(NVIC_PriorityGroup_2);//ϵͳжȼ2
	delay_init(168);  //ʼʱ
	uart_init(115200);		//ʼڲΪ115200
	
	LED_Init();					//ʼLED
	KEY_Init();					//ʼ
 
	Lcd_Init();	 //1.44Һ--ʼ
	
	Lcd_Clear(GRAY0);//
	Gui_DrawFont_GBK16(0,16,RED,GRAY0,"  DSP BasicMath   ");
  Gui_DrawFont_GBK16(0,32,BLUE,GRAY0,"  Ƕʽ   ");	 
	Gui_DrawFont_GBK16(0,48,BLUE,GRAY0,"mcudev.taobao.com ");
		
	
 	TIM3_Int_Init(65535,8400-1);//10KhzƵ,ʱ6.5볬
	
	Gui_DrawFont_GBK16(0,80,BLUE,GRAY0,"No DSP: ");	//ʾʾϢ
	Gui_DrawFont_GBK16(0,96,BLUE,GRAY0,"Use DSP: ");	//ʾʾϢ	
 
	while(1)
	{
		
		//ʹDSPŻ
		TIM_SetCounter(TIM3,0);//TIM3ʱļֵ
		timeout=0;
		res=sin_cos_test(PI/6,200000,0);
		time=TIM_GetCounter(TIM3)+(u32)timeout*65536;
		sprintf((char*)buf,"%0.1fms",time/10);
		if(res==0)
			Gui_DrawFont_GBK16(72,80,BLUE,GRAY0,buf);	//ʾʱ		
		else 
			Gui_DrawFont_GBK16(72,80,BLUE,GRAY0,"error");	//ʾǰ	
		//ʹDSPŻ		
		TIM_SetCounter(TIM3,0);//TIM3ʱļֵ
		timeout=0;
		res=sin_cos_test(PI/6,200000,1);
		time=TIM_GetCounter(TIM3)+(u32)timeout*65536;
		sprintf((char*)buf,"%0.1fms",time/10);
		if(res==0)
			Gui_DrawFont_GBK16(72,96,BLUE,GRAY0,buf);	//ʾʱ	
		else 
			Gui_DrawFont_GBK16(72,96,BLUE,GRAY0,"error");	//ʾ	
		LED2=!LED2;
	}
}
 
