#include "sys.h"
#include "delay.h"  
#include "usart.h"  
#include "led.h"
#include "key.h"

#include "timer.h" 
#include "math.h" 
#include "arm_math.h"  

#include "GUI.h"
#include "Lcd_Driver.h"

//DSP FFTʵ   -⺯汾
//STM32F4ģ-⺯汾
//Ա̣http://mcudev.taobao.com		


#define FFT_LENGTH		1024 		//FFTȣĬ1024FFT

float fft_inputbuf[FFT_LENGTH*2];	//FFT
float fft_outputbuf[FFT_LENGTH];	//FFT

u8 timeout;//ʱ


int main(void)
{ 
  arm_cfft_radix4_instance_f32 scfft;
 	u8 key,t=0;
	float time; 
	u8 buf[50]; 
	u16 i; 

	NVIC_PriorityGroupConfig(NVIC_PriorityGroup_2);//ϵͳжȼ2
	delay_init(168);  //ʼʱ
	uart_init(115200);		//ʼڲΪ115200
	
	LED_Init();					//ʼLED
	KEY_Init();					//ʼ
 	
		Lcd_Init();	 //1.44Һ--ʼ
	
	Lcd_Clear(GRAY0);//
	Gui_DrawFont_GBK16(0,16,RED,GRAY0,"    DSP FFT       ");
  Gui_DrawFont_GBK16(0,32,BLUE,GRAY0,"  Ƕʽ   ");	 
	Gui_DrawFont_GBK16(0,48,BLUE,GRAY0,"mcudev.taobao.com ");
	Gui_DrawFont_GBK16(0,64,BLUE,GRAY0,"KEY1:Run FFT");//ʾʾϢ 
	Gui_DrawFont_GBK16(0,80,BLUE,GRAY0,"FFT runtime:");//ʾFFTִʱ
	
	TIM3_Int_Init(65535,84-1);	//1MhzƵ,ʱ65msҳ
 
	arm_cfft_radix4_init_f32(&scfft,FFT_LENGTH,0,1);//ʼscfftṹ壬趨FFTز
 	while(1)
	{
		key=KEY_Scan(0);
		if(key==KEY1_PRES)
		{
			for(i=0;i<FFT_LENGTH;i++)//ź
			{
				 fft_inputbuf[2*i]=100+
				                   10*arm_sin_f32(2*PI*i/FFT_LENGTH)+
								   30*arm_sin_f32(2*PI*i*4/FFT_LENGTH)+
				                   50*arm_cos_f32(2*PI*i*8/FFT_LENGTH);	//źʵ
				 fft_inputbuf[2*i+1]=0;//鲿ȫΪ0
			}
			TIM_SetCounter(TIM3,0);//TIM3ʱļֵ
			timeout=0;
			arm_cfft_radix4_f32(&scfft,fft_inputbuf);	//FFT㣨4
			time=TIM_GetCounter(TIM3)+(u32)timeout*65536; 			//ʱ
			sprintf((char*)buf,"         %0.3fms",time/1000);
			
			Gui_DrawFont_GBK16(0,96,BLUE,GRAY0,"               ");	//ʾʱ		
			Gui_DrawFont_GBK16(0,96,BLUE,GRAY0,buf);	//ʾʱ		
			
			arm_cmplx_mag_f32(fft_inputbuf,fft_outputbuf,FFT_LENGTH);	//ģ÷ֵ 
			printf("\r\n%d point FFT runtime:%0.3fms\r\n",FFT_LENGTH,time/1000);
			printf("FFT Result:\r\n");
			
			for(i=0;i<FFT_LENGTH;i++)
			{
				printf("fft_outputbuf[%d]:%f\r\n",i,fft_outputbuf[i]);
			}
		}else delay_ms(10);
		t++;
		if((t%10)==0)LED2=!LED2;		  
	}
}
 
