#include "adc.h"
#include "delay.h"		 
//////////////////////////////////////////////////////////////////////////////////	 
//ADC 	   
//STM32F4ģ-⺯汾
//Ա̣http://mcudev.taobao.com									  
////////////////////////////////////////////////////////////////////////////////// 	


//ʼADC
//ǽԹͨΪ
//¶ȴͨ																   
void  Adc_Init(void)
{    
  GPIO_InitTypeDef  GPIO_InitStructure;
	ADC_CommonInitTypeDef ADC_CommonInitStructure;
	ADC_InitTypeDef       ADC_InitStructure;
	
  RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOA, ENABLE);//ʹGPIOAʱ
  RCC_APB2PeriphClockCmd(RCC_APB2Periph_ADC1, ENABLE);//ʹADC1ʱ

  //ȳʼIO
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_5;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AN;//ģ
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;// 
  GPIO_Init(GPIOA, &GPIO_InitStructure);//ʼ  
 
	RCC_APB2PeriphResetCmd(RCC_APB2Periph_ADC1,ENABLE);	//ADC1λ
	RCC_APB2PeriphResetCmd(RCC_APB2Periph_ADC1,DISABLE);	//λ	 
 
  ADC_TempSensorVrefintCmd(ENABLE);//ʹڲ¶ȴ
	
  ADC_CommonInitStructure.ADC_Mode = ADC_Mode_Independent;//ģʽ
  ADC_CommonInitStructure.ADC_TwoSamplingDelay = ADC_TwoSamplingDelay_5Cycles;
  ADC_CommonInitStructure.ADC_DMAAccessMode = ADC_DMAAccessMode_Disabled; //DMAʧ
  ADC_CommonInitStructure.ADC_Prescaler = ADC_Prescaler_Div4; //ADCCLK=PCLK2/4=84/4=21Mhz,ADCʱòҪ36Mhz
  ADC_CommonInit(&ADC_CommonInitStructure);
	
  ADC_InitStructure.ADC_Resolution = ADC_Resolution_12b;//12λģʽ
  ADC_InitStructure.ADC_ScanConvMode = DISABLE;//ɨģʽ	
  ADC_InitStructure.ADC_ContinuousConvMode = DISABLE;
  ADC_InitStructure.ADC_ExternalTrigConvEdge = ADC_ExternalTrigConvEdge_None;//ֹ⣬ʹ
  ADC_InitStructure.ADC_DataAlign = ADC_DataAlign_Right;//Ҷ	
  ADC_InitStructure.ADC_NbrOfConversion = 1;//1תڹ Ҳֻת1 
  ADC_Init(ADC1, &ADC_InitStructure);
 
	ADC_RegularChannelConfig(ADC1, ADC_Channel_5, 1, ADC_SampleTime_480Cycles );	//ADC5,ADCͨ,480,߲ʱ߾ȷ		
	ADC_RegularChannelConfig(ADC1, ADC_Channel_16, 1, ADC_SampleTime_480Cycles );	//ADC16,ADCͨ,480,߲ʱ߾ȷ		
	ADC_Cmd(ADC1, ENABLE);//ADת	 			
 
}				  
//ADCֵ
//ch:ֵͨ @ref ADC_channels  0~16ADC_Channel_0~ADC_Channel_16
//ֵ:ת
u16 Get_Adc(u8 ch)   
{
	 //ָADCĹͨһУʱ
	ADC_RegularChannelConfig(ADC1, ch, 1, ADC_SampleTime_480Cycles );	//ADC1,ADCͨ,480,߲ʱ߾ȷ			    
  
	ADC_SoftwareStartConv(ADC1);		//ʹָADC1ת	
	 
	while(!ADC_GetFlagStatus(ADC1, ADC_FLAG_EOC ));//ȴת

	return ADC_GetConversionValue(ADC1);	//һADC1ת
}
//ȡͨchתֵȡtimes,Ȼƽ 
//ch:ͨ
//times:ȡ
//ֵ:ͨchtimesתƽֵ
u16 Get_Adc_Average(u8 ch,u8 times)
{
	u32 temp_val=0;
	u8 t;
	for(t=0;t<times;t++)
	{
		temp_val+=Get_Adc(ch);//ȡͨתֵ
		delay_ms(5);
	}
	return temp_val/times;
} 

//õ¶ֵ
//ֵ:¶ֵ(100,λ:.)
short Get_Temprate(void)
{
	u32 adcx;
	short result;
 	double temperate;
	adcx=Get_Adc_Average(ADC_Channel_16,10);	//ȡͨ16ڲ¶ȴͨ,10ȡƽ
	temperate=(float)adcx*(3.3/4096);		//ѹֵ
	temperate=(temperate-0.76)/0.0025 + 25; //תΪ¶ֵ 
	result=temperate*=100;					//100.
	return result;
}
	 










