#include "sys.h"
#include "delay.h"
#include "usart.h"
#include "led.h"

#include "adc.h"
#include "dac.h"
#include "key.h"

#include "GUI.h"
#include "Lcd_Driver.h"


//DACʵ-⺯汾
//STM32F4ģ-⺯汾
//Ա̣http://mcudev.taobao.com


	u8 tbuf[40];
	u8 t=0; 
	
	u16 adcx;
	float temp;
	
 	 
	u16 dacval=0;
	u8 key; 
  u8 Numt=0;
	
	
int main(void)
{ 
		
	
	NVIC_PriorityGroupConfig(NVIC_PriorityGroup_2);//ϵͳжȼ2
	delay_init(168);      //ʼʱ
	uart_init(115200);		//ʼڲΪ115200
	
	LED_Init();					//ʼLED 
 	
	 	 	Lcd_Init();	 //1.44Һ--ʼ
	Lcd_Clear(GRAY0);//
	Gui_DrawFont_GBK16(0,16,RED,GRAY0,"    STM32 DAC ");
  Gui_DrawFont_GBK16(0,32,BLUE,GRAY0,"  Ƕʽ   ");	 
	Gui_DrawFont_GBK16(0,48,BLUE,GRAY0,"mcudev.taobao.com "); 
	
	Adc_Init(); 				//adcʼ
	KEY_Init(); 				//ʼ
	Dac1_Init();		 		//DACͨ1ʼ	
	
	Gui_DrawFont_GBK16(0,64,BLUE,GRAY0,"DAC VAL:");	      
	Gui_DrawFont_GBK16(0,80,BLUE,GRAY0,"DAC VOL:0.000V");	      
	Gui_DrawFont_GBK16(0,96,BLUE,GRAY0,"ADC VOL:0.000V");
 	
  DAC_SetChannel1Data(DAC_Align_12b_R,dacval);//ʼֵΪ0	
	while(1)
	{
		Numt++;
		key=KEY_Scan(0);
		
		if(key==KEY1_PRES)
		{		 
			if(dacval<4000)dacval+=200;
			DAC_SetChannel1Data(DAC_Align_12b_R, dacval);//DACֵ
		}
		
		if(Numt>=10) 	//ʱʱ䵽
		{	  
 			adcx=DAC_GetDataOutputValue(DAC_Channel_1);//ȡǰDACֵ
			sprintf((char*)tbuf,"DAC VAL:0x%02X",adcx);      	   //ʾDACĴֵ
			Gui_DrawFont_GBK16(0,64,BLUE,GRAY0,tbuf);	
			
			temp=(float)adcx*(3.3/4096);			         //õDACѹֵ
			sprintf((char*)tbuf,"DAC VOL:%06.3f V",temp); 
      	
			Gui_DrawFont_GBK16(0,80,BLUE,GRAY0,tbuf);	
      printf("DACѹ:%06.4f V\r\n",temp);//ڴӡ						

 			adcx=Get_Adc_Average(ADC_Channel_5,10);		//õADCתֵ	  
			temp=(float)adcx*(3.3/4096);			        //õADCѹֵ
			
			sprintf((char*)tbuf,"ADC VOL:%06.3f V",temp);
			
			Gui_DrawFont_GBK16(0,96,BLUE,GRAY0,tbuf);
      printf("ADCѹ:%06.4f V\r\n",temp);//ڴӡ					
			
			LED2=!LED2;	   
			Numt=0;
		}	    
		delay_ms(50);	 
	}	
}

