#include "sys.h"
#include "delay.h"
#include "usart.h"
#include "led.h"

#include "key.h"  
#include "dma.h"

#include "GUI.h"
#include "Lcd_Driver.h"

//DMA ʵ-⺯汾  
//STM32F4ģ-⺯汾
//Ա̣http://mcudev.taobao.com	


#define SEND_BUF_SIZE 8200	//ݳ,õsizeof(TEXT_TO_SEND)+2.

u8 SendBuff[SEND_BUF_SIZE];	//ݻ
const u8 TEXT_TO_SEND[]={"Mcudev STM32F4 DMA ʵ"};	 


	u8 tbuf[40];
	u8 t=0;
 	u16 adcx;
	float temp;
  
int main(void)
{ 
	u16 i;
	u8 t=0;
	u8 j,mask=0;
	float pro=0;//
	NVIC_PriorityGroupConfig(NVIC_PriorityGroup_2);//ϵͳжȼ2
	delay_init(168);     //ʼʱ
	uart_init(115200);	//ʼڲΪ115200
	LED_Init();					//ʼLED 
	
 		 	Lcd_Init();	 //1.44Һ--ʼ
	Lcd_Clear(GRAY0);//
	Gui_DrawFont_GBK16(0,16,RED,GRAY0,"    STM32 DMA ");
  Gui_DrawFont_GBK16(0,32,BLUE,GRAY0,"  Ƕʽ   ");	 
	Gui_DrawFont_GBK16(0,48,BLUE,GRAY0,"mcudev.taobao.com "); 
	Gui_DrawFont_GBK16(0,64,BLUE,GRAY0,"KEY1:Start");	 
	
	KEY_Init(); 				//ʼ 
	
 	MYDMA_Config(DMA2_Stream7,DMA_Channel_4,(u32)&USART1->DR,(u32)SendBuff,SEND_BUF_SIZE);//DMA2,STEAM7,CH4,Ϊ1,洢ΪSendBuff,Ϊ:SEND_BUF_SIZE.
	

	
	   	 
 //ʾʾϢ	
	j=sizeof(TEXT_TO_SEND);	   
	for(i=0;i<SEND_BUF_SIZE;i++)//ASCIIַ
    {
		if(t>=j)//뻻з
		{
			if(mask)
			{
				SendBuff[i]=0x0a;
				t=0;
			}else 
			{
				SendBuff[i]=0x0d;
				mask++;
			}	
		}else//TEXT_TO_SEND
		{
			mask=0;
			SendBuff[i]=TEXT_TO_SEND[t];
			t++;
		}   	   
    }		 
	
	i=0;
	while(1)
	{
		t=KEY_Scan(0);
		if(t==KEY1_PRES)  //KEY1
		{
			printf("\r\nDMA DATA:\r\n"); 	    
			Gui_DrawFont_GBK16(0,80,BLUE,GRAY0,"Start Transimit....");
			Gui_DrawFont_GBK16(0,96,BLUE,GRAY0,"   %") ;     //ʾٷֺ    
			
      USART_DMACmd(USART1,USART_DMAReq_Tx,ENABLE);  //ʹܴ1DMA     
			MYDMA_Enable(DMA2_Stream7,SEND_BUF_SIZE);     //ʼһDMA䣡	  
		    //ȴDMAɣʱһЩ£
		    //ʵӦУڼ䣬ִ
		    while(1)
		    {
				if(DMA_GetFlagStatus(DMA2_Stream7,DMA_FLAG_TCIF7)!=RESET)//ȴDMA2_Steam7
				{ 
					DMA_ClearFlag(DMA2_Stream7,DMA_FLAG_TCIF7);//DMA2_Steam7ɱ־
					break; 
		        }
				pro=DMA_GetCurrDataCounter(DMA2_Stream7);//õǰʣٸ
				pro=1-pro/SEND_BUF_SIZE;//õٷֱ	  
				pro*=100;      			    //100
						
				sprintf((char*)tbuf,"%04.2f",pro);		
				Gui_DrawFont_GBK16(0,96,BLUE,GRAY0,tbuf) ;     //ʾٷֺ     
						
						
		    }			    
				sprintf((char*)tbuf,"  100");		
				Gui_DrawFont_GBK16(0,96,BLUE,GRAY0,tbuf) ;     //ʾٷֺ   
		}
		i++;
		delay_ms(10);
		if(i==20)
		{
			
			LED2=!LED2;//ʾϵͳ	
			i=0;
		}		   
	}		    
}

