#include "sys.h"
#include "delay.h"
#include "usart.h"
#include "led.h"

#include "spi.h"
#include "w25qxx.h"
#include "key.h"  

#include "GUI.h"
#include "Lcd_Driver.h"

//SPIͨŽӿʵ-⺯汾
//STM32F4ģ-⺯汾
//Ա̣http://mcudev.taobao.com			
 
 	u8 tbuf[40];
	u8 t=0;
 	u16 adcx;
	
 
//Ҫд뵽W25Q16ַ
const u8 TEXT_Buffer[]={"mcudev STM32F4 SPI TEST"};
#define SIZE sizeof(TEXT_Buffer)	 
	
int main(void)
{ 
	u8 key;
	u16 i=0;
	u8 datatemp[SIZE];
	u32 FLASH_SIZE;
	NVIC_PriorityGroupConfig(NVIC_PriorityGroup_2);//ϵͳжȼ2
	delay_init(168);     //ʼʱ
	uart_init(115200);	//ʼڲΪ115200
	LED_Init();					//ʼLED 
 	
	KEY_Init(); 				//ʼ  
	W25QXX_Init();			//W25QXXʼ
 
	 	Lcd_Init();	 //1.44Һ--ʼ
	Lcd_Clear(GRAY0);//
	Gui_DrawFont_GBK16(0,16,RED,GRAY0,"STM32 SPI-W25Q16 ");
  Gui_DrawFont_GBK16(0,32,BLUE,GRAY0,"  Ƕʽ   ");	 
	Gui_DrawFont_GBK16(0,48,BLUE,GRAY0,"mcudev.taobao.com ");
	Gui_DrawFont_GBK16(0,64,BLUE,GRAY0,"KEY1:Write&Read");	//ʾʾϢ		
	
	while(W25QXX_ReadID()!=W25Q16)								//ⲻW25Q16
	{
		Gui_DrawFont_GBK16(0,80,BLUE,GRAY0,"W25Q16 Check Failed!");
		delay_ms(500);
		Gui_DrawFont_GBK16(0,96,BLUE,GRAY0,"Please Check!      ");
		delay_ms(500);
		LED2=!LED2;		//D3˸
	}
	adcx=W25QXX_ReadID();//ȡID
	sprintf((char*)tbuf,"W25Q16 ID:0x%X",adcx); 
	Gui_DrawFont_GBK16(0,80,BLUE,GRAY0,tbuf); 
	FLASH_SIZE=16*1024*1024;	//FLASH СΪ2Mֽ
  
	while(1)
	{
		key=KEY_Scan(0);
		if(key==KEY1_PRES)//KEY1,дW25Q16
		{
			 
 			Gui_DrawFont_GBK16(0,96,BLUE,GRAY0,"Start Write W25Q16....");
			Gui_DrawFont_GBK16(0,112,BLUE,GRAY0,"                     ");					//ʾַ
			
			W25QXX_Write((u8*)TEXT_Buffer,FLASH_SIZE-100,SIZE);		//ӵ100ַʼ,дSIZEȵ
			Gui_DrawFont_GBK16(0,96,BLUE,GRAY0,"W25Q16 Write Finished!");	//ʾ
			
			Gui_DrawFont_GBK16(0,96,BLUE,GRAY0,"Start Read W25Q16.... ");
			W25QXX_Read(datatemp,FLASH_SIZE-100,SIZE);					//ӵ100ַʼ,SIZEֽ
			Gui_DrawFont_GBK16(0,96,BLUE,GRAY0,"The Data Readed Is:   ");	//ʾ
			sprintf((char*)tbuf,&datatemp[0]); 
			Gui_DrawFont_GBK16(0,112,BLUE,GRAY0,tbuf);					//ʾַ
		}
 
		i++;
		delay_ms(10);
		if(i==20)
		{
			LED2=!LED2;//ʾϵͳ	
			i=0;
		}		   
	}       
}

