#include "usbd_msc_mem.h"
#include "usb_conf.h"
#include "w25qxx.h"			 
#include "sdio_sdcard.h"	 
//////////////////////////////////////////////////////////////////////////////////	 

//USB  	   
//STM32F4ģ-⺯汾
//Ա̣http://mcudev.taobao.com			
////////////////////////////////////////////////////////////////////////////////// 	   
 
//ֵ֧豸,2
#define STORAGE_LUN_NBR 	1

////////////////////////////ԼһUSB״̬ļĴ///////////////////
//bit0:ʾSDд
//bit1:ʾSD
//bit2:SDдݴ־λ
//bit3:SDݴ־λ
//bit4:1,ʾѯ(ӻ)
vu8 USB_STATUS_REG=0;
////////////////////////////////////////////////////////////////////////////////


//USB Mass storage ׼ѯ(ÿlunռ36ֽ)
const int8_t  STORAGE_Inquirydata[] = { 
  
	
	/* LUN 0 */
	0x00,
	0x80,		
	0x02,		
	0x02,
	(USBD_STD_INQUIRY_LENGTH - 4),
	0x00,
	0x00,	
	0x00,
	/* Vendor Identification */
	'M', 'c', 'u', 'd', 'e', 'v', ' ', //ֽ
	/* Product Identification */				
	//'F', 'L', 'A', 'S', 'H', ' ', ' ', ' ', ' ',//ֽ
	' ','D', 'i', 's', 'k', ' ',   
    /* Product Revision Level */
	//'1', '.', '0' ,' ',                      	//ֽ
}; 



int8_t STORAGE_Init (uint8_t lun);
int8_t STORAGE_GetCapacity (uint8_t lun,uint32_t *block_num,uint32_t *block_size);
int8_t  STORAGE_IsReady (uint8_t lun);
int8_t  STORAGE_IsWriteProtected (uint8_t lun);
int8_t STORAGE_Read (uint8_t lun,uint8_t *buf,uint32_t blk_addr,uint16_t blk_len);
int8_t STORAGE_Write (uint8_t lun,uint8_t *buf,uint32_t blk_addr,uint16_t blk_len);
int8_t STORAGE_GetMaxLun (void);



//USB Device ûصӿ
USBD_STORAGE_cb_TypeDef USBD_MICRO_SDIO_fops =
{
	STORAGE_Init,
	STORAGE_GetCapacity,
	STORAGE_IsReady,
	STORAGE_IsWriteProtected,
	STORAGE_Read,
	STORAGE_Write,
	STORAGE_GetMaxLun,
	(int8_t *)STORAGE_Inquirydata,
};


USBD_STORAGE_cb_TypeDef  *USBD_STORAGE_fops=&USBD_MICRO_SDIO_fops;//ָUSBD_MICRO_SDIO_fopsṹ.

//ʼ洢豸
//lun:߼Ԫ,0,SD;1,SPI FLASH
//ֵ:0,ɹ;
//    ,
int8_t STORAGE_Init (uint8_t lun)
{
	//SD_Init();
	W25QXX_Init();
	return 0; 
} 

//ȡ洢豸ͿС
//lun:߼Ԫ,0,SD;1,SPI FLASH
//block_num:()
//block_size:С(С)
//ֵ:0,ɹ;
//    ,
int8_t STORAGE_GetCapacity (uint8_t lun, uint32_t *block_num, uint32_t *block_size)
{     
//	if(lun==1)
//	{
//		*block_size=512;  
//		*block_num=SDCardInfo.CardCapacity/512;
//	}else
//	{
		*block_size=512;  
		*block_num=1024*1024*2/512;	//SPI FLASHǰ2Mֽ,ļϵͳ
//	}	
	return 0; 
} 

//鿴洢豸Ƿ
//lun:߼Ԫ,0,SD;1,SPI FLASH
//ֵ:0,;
//    ,δ
int8_t  STORAGE_IsReady (uint8_t lun)
{ 
	USB_STATUS_REG|=0X10;//ѯ
	return 0;
} 

//鿴洢豸Ƿд
//lun:߼Ԫ,0,SD;1,SPI FLASH
//ֵ:0,ûд;
//    ,д(ֻ)
int8_t  STORAGE_IsWriteProtected (uint8_t lun)
{
	return  0;
} 

//Ӵ洢豸ȡ
//lun:߼Ԫ,0,SD;1,SPI FLASH
//buf:ݴ洢׵ַָ
//blk_addr:Ҫȡĵַ(ַ)
//blk_len:ҪȡĿ() 
//ֵ:0,ɹ;
//    , 
int8_t STORAGE_Read (uint8_t lun,uint8_t *buf,uint32_t blk_addr,uint16_t blk_len)
{
	int8_t res=0;
	USB_STATUS_REG|=0X02;//ڶ
//	if(lun==1)
//	{
// 		res=SD_ReadDisk(buf,blk_addr,blk_len);
//		if(res)USB_STATUS_REG|=0X08;//SD!
//	}else
//	{
		W25QXX_Read(buf,blk_addr*512,blk_len*512);
//	} 
	return res;
}
//洢豸д
//lun:߼Ԫ,0,SD;1,SPI FLASH
//buf:ݴ洢׵ַָ
//blk_addr:Ҫдĵַ(ַ)
//blk_len:ҪдĿ() 
//ֵ:0,ɹ;
//    , 
int8_t STORAGE_Write (uint8_t lun,uint8_t *buf,uint32_t blk_addr,uint16_t blk_len) 
{
	int8_t res=0;
	USB_STATUS_REG|=0X01;//д
//	if(lun==1)
//	{
//		res=SD_WriteDisk (buf,blk_addr,blk_len);
//		if(res)USB_STATUS_REG|=0X04;//SDд!	 
//	}else
//	{
		W25QXX_Write(buf,blk_addr*512,blk_len*512);
//	} 
	return res; 
}
//ȡֵ֧߼Ԫ
//ֵ:ֵ֧߼Ԫ-1
int8_t STORAGE_GetMaxLun (void)
{
	return (STORAGE_LUN_NBR - 1);
}
























