#include "sys.h"
#include "delay.h"  
#include "usart.h"   
#include "led.h"

#include "key.h"   
#include "malloc.h" 
#include "w25qxx.h"    
#include "sdio_sdcard.h"    
#include "usbd_msc_core.h"
#include "usbd_usr.h"
#include "usbd_desc.h"
#include "usb_conf.h" 

#include "GUI.h"
#include "Lcd_Driver.h"

//STM32F407 
//USB --U ʵ -⺯汾
//STM32F4ģ-⺯汾
//Ա̣http://mcudev.taobao.com			
 

USB_OTG_CORE_HANDLE USB_OTG_dev;
extern vu8 USB_STATUS_REG;		//USB״̬
extern vu8 bDeviceState;		//USB 
 

	u8 offline_cnt=0;
	u8 tct=0;
	u8 USB_STA;
	u8 Divece_STA;
 
int main(void)
{        



	NVIC_PriorityGroupConfig(NVIC_PriorityGroup_2);//ϵͳжȼ2
	delay_init(168);  //ʼʱ
	uart_init(115200);		//ʼڲΪ115200
	LED_Init();					//ʼLED  
 	
 	KEY_Init();					//ʼ  
	W25QXX_Init();				//ʼW25Q16  
  
	USBD_Init(&USB_OTG_dev,USB_OTG_FS_CORE_ID,&USR_desc,&USBD_MSC_cb,&USR_cb);
	
	Lcd_Init();	 //1.44Һ--ʼ
	Lcd_Clear(GRAY0);//
	Gui_DrawFont_GBK16(0,16,RED,GRAY0," STM32 USB Disk   ");
  Gui_DrawFont_GBK16(0,32,BLUE,GRAY0,"  Ƕʽ   ");	 
	Gui_DrawFont_GBK16(0,48,BLUE,GRAY0,"mcudev.taobao.com ");

	if(W25QXX_ReadID()!=W25Q16)
		Gui_DrawFont_GBK16(0,64,BLUE,GRAY0,"W25Q16 Error!");	//W25Q128
	else //SPI FLASH 
	{   														 
		Gui_DrawFont_GBK16(0,64,BLUE,GRAY0,"FLASH Size:2MB");	 
	} 
	
	delay_ms(1000);
	
	while(1)
	{	
		delay_ms(1);
		
		if(USB_STA!=USB_STATUS_REG)//״̬ı 
		{	 						   
					  	   
			
			if(USB_STATUS_REG&0x01)//д		  
			{
				LED2=0;
				Gui_DrawFont_GBK16(0,64,BLUE,GRAY0,"USB Writing...");//ʾUSBд	 
			}
			if(USB_STATUS_REG&0x02)//ڶ
			{
				LED2=0;
				Gui_DrawFont_GBK16(0,64,BLUE,GRAY0,"USB Reading...");//ʾUSBڶ  		 
			}	 
			
 
			USB_STA=USB_STATUS_REG;//¼״̬
		}
		if(Divece_STA!=bDeviceState) 
		{
			if(bDeviceState==1)
				Gui_DrawFont_GBK16(0,64,BLUE,GRAY0,"USB Connected    ");//ʾUSBѾ
			else 
				Gui_DrawFont_GBK16(0,64,BLUE,GRAY0,"USB DisConnected ");//ʾUSBγ
			
			Divece_STA=bDeviceState;
		}
		
		tct++;
		
		if(tct==200)
		{
			tct=0;
			
			LED2=!LED2;//ʾϵͳ
			
			if(USB_STATUS_REG&0x10)
			{
				offline_cnt=0;//USB,offline
				bDeviceState=1;
				
			}
			else//ûеõѯ 
			{
				offline_cnt++;  
				
				if(offline_cnt>20)bDeviceState=0;//2sûյ߱,USBγ
			}
			
			USB_STATUS_REG=0;
		}
	};  
}




