#include "exti.h"
#include "delay.h" 
#include "led.h" 
#include "key.h"


//////////////////////////////////////////////////////////////////////////////////	 
//STM32F4ģ-⺯汾
//Ա̣http://mcudev.taobao.com								  
////////////////////////////////////////////////////////////////////////////////// 

//ⲿж0
void EXTI0_IRQHandler(void)
{
	delay_ms(10);	//
	if(Key1==1)	 
	{
		LED2=!LED2;
	}		 
	 EXTI_ClearITPendingBit(EXTI_Line0); //LINE0ϵжϱ־λ 
}	

//ⲿж1  PA1
void EXTI1_IRQHandler(void)
{
	delay_ms(10);	//
	if(EXT_IO1==0)	  
	{				 
   LED2=!LED2;
	}		 
	 EXTI_ClearITPendingBit(EXTI_Line2);//LINE2ϵжϱ־λ 
}



	   
//ⲿжϳʼ
//ʼPA0,PA1Ϊж.
void EXTIX_Init(void)
{
	NVIC_InitTypeDef   NVIC_InitStructure;
	EXTI_InitTypeDef   EXTI_InitStructure;
	GPIO_InitTypeDef  GPIO_InitStructure;
	
	KEY_Init(); //ӦIOڳʼ
 
	//ӦIOڳʼ  PA1  һͨIOж
	RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOA, ENABLE);//ʹGPIOAʱ
	
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_1; //Ӧ
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN;//ͨģʽ
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;//100M
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;//
  GPIO_Init(GPIOA, &GPIO_InitStructure);//ʼPE2,3
	

	
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_SYSCFG, ENABLE);//ʹSYSCFGʱ
	
 
	SYSCFG_EXTILineConfig(EXTI_PortSourceGPIOA, EXTI_PinSource1);//PA1 ӵж1
	SYSCFG_EXTILineConfig(EXTI_PortSourceGPIOA, EXTI_PinSource0);//PA0 ӵж0
	
  /* EXTI_Line0 */
  EXTI_InitStructure.EXTI_Line = EXTI_Line0;//LINE0
  EXTI_InitStructure.EXTI_Mode = EXTI_Mode_Interrupt;//ж¼
  EXTI_InitStructure.EXTI_Trigger = EXTI_Trigger_Rising; //ش 
  EXTI_InitStructure.EXTI_LineCmd = ENABLE;//ʹLINE0
  EXTI_Init(&EXTI_InitStructure);//
	
	/* EXTI_Line1*/
	EXTI_InitStructure.EXTI_Line = EXTI_Line1 ;
  EXTI_InitStructure.EXTI_Mode = EXTI_Mode_Interrupt;//ж¼
  EXTI_InitStructure.EXTI_Trigger = EXTI_Trigger_Falling; //½ش
  EXTI_InitStructure.EXTI_LineCmd = ENABLE;//жʹ
  EXTI_Init(&EXTI_InitStructure);//



/******** жȼ****/

	NVIC_InitStructure.NVIC_IRQChannel = EXTI0_IRQn;//ⲿж0
  NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0x00;//ռȼ0
  NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0x02;//ȼ2
  NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;//ʹⲿжͨ
  NVIC_Init(&NVIC_InitStructure);//
	
	NVIC_InitStructure.NVIC_IRQChannel = EXTI1_IRQn;//ⲿж1
  NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0x03;//ռȼ3
  NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0x02;//ȼ2
  NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;//ʹⲿжͨ
  NVIC_Init(&NVIC_InitStructure);//
	
	   
}












